function mouseOver (pos)
	local x, y = love.mouse.getPosition( )
	if x >= pos[1] and y >= pos[2] and x <= pos[3] and y <= pos[4] then
		return true
	end
	return false
end

function drawButtons()
	local width, height
	for _, b in pairs(buttons) do
		width = b[3] - b[1]
		height = b[4] - b[2]
		love.graphics.rectangle("line", b[1], b[2], width, height)
		love.graphics.print(b.text, b[1] + b.offset, b[2] + 15)
	end
end

function love.draw()
	drawButtons()
	local line = 0
	local x = 50
	local baseY = 70
	local y = baseY
	local count = 0
	local alt, rect
	for k, v in pairs(t) do
		count = count + 1
		if alt then
			alt = false
			love.graphics.setColor(0.1, 0.1, 0.1)
		else
			alt = true
			love.graphics.setColor(0.2, 0.2, 0.2)
		end
		
		love.graphics.rectangle("fill", x - 10, y - 1, 430, 19)
		rect = {x - 10, y - 1, x + 200, y + 19}
		if type(v) == "table" and mouseOver(rect) then
			love.graphics.setColor(1, 0, 0)
			if love.mouse.isDown(1) then
				uplevel = t
				t = v
			end
		else
			love.graphics.setColor(1, 1, 1)
		end
		love.graphics.print(k, x, y)
		
		love.graphics.setColor(1, 1, 1)
		love.graphics.print(tostring(v), x + 250, y)
		y = y + 20
		if y > 770 then
			x = x + 500
			y = baseY
		end
	end
	love.graphics.print("Size: " .. count, 10, 10)
end

function love.load()
    love.window.setMode(1600, 800)
    love.window.setTitle("Global environment browser")
    t = love
    uplevel = _G
    buttons = {
		{150, 10, 340, 55, text = "Up one level", offset = 60},
		{500, 10, 690, 55, text = "Home", offset = 80},
		{850, 10, 1040, 55, text = "_G", offset = 90},
		{1200, 10, 1390, 55, text = "Quit", offset = 80}
	}
end

function love.update(dt)
	love.timer.sleep(0.05)
	
	-- Check for button clicks
	if love.mouse.isDown(1) then
		
		-- Up
		if mouseOver(buttons[1]) then
			t = uplevel
		end
		
		-- Home
		if mouseOver(buttons[2]) then
			t = love
			uplevel = _G
		end
		
		-- _G
		if mouseOver(buttons[3]) then
			t = _G
			uplevel = _G
			love.timer.sleep(0.1)
		end
		
		-- Quit
		if mouseOver(buttons[4]) then
			os.exit()
		end
		
		-- Stop accidental repeats
		love.timer.sleep(0.2)
	end
end
